package 
{
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;

	import com.eclecticdesignstudio.motion.Actuate;
	
	/**
	 * ...
	 * @author michal@ninevectors.com
	 */
	public class Main extends Sprite 
	{
		
		private var joystickClip : MovieClip;
		private var primaryLine:TextField, secondaryLine:TextField;
		private var labelContainer:Sprite, box1:Sprite, box2:Sprite;
		private var textStyle1:TextFormat, textStyle2:TextFormat;
		private var controllerNames:Array, additionalDesc:Array;
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			primaryLine = new TextField();
			secondaryLine = new TextField();
			primaryLine.width = 380;
			secondaryLine.width = 380;
			textStyle1 = new TextFormat("Arial",18,0xffffff);
			textStyle2 = new TextFormat("Arial",12,0x000000);
			primaryLine.defaultTextFormat = textStyle1;
			secondaryLine.defaultTextFormat = textStyle2;
			controllerNames = new Array (
				"Selection wheel",
				"Throttle lever",
				"Main fire button",
				"Top fire buttons",
				"Side auxiliary button",
				"Programmable button"
			);
			additionalDesc = new Array (
				"Mostly used for selecting items, changing targets",
				"It works great as an engine controller in flight simulators \nor throttle controller in other vehicles",
				"Mostly used as a main gun, however is also configurable \nas other buttons",
				"Used for launchig rockets, throwing grenades \nor controlling secondary weapon",
				"It has many practical applications like map preview, weapon reload, \nwhatever that might be handy in controlling your game.",
				"Configurable buttons, no predifined fuction."	
			);
			stage.stageFocusRect = false;
			loadJoystick();
		}
		
		private function prepareLabel():void 
		{
			labelContainer = new Sprite();
			labelContainer.y = stage.stageHeight - 60;
			box1 = new Sprite();
			box1.graphics.beginFill(0x000000, 1);
			box1.graphics.drawRect(0,0,stage.stageWidth-2,58);
			box1.graphics.endFill();
			box1.y = 0;
			labelContainer.addChild(box1);
			box2 = new Sprite();
			box2.graphics.beginFill(0xffffff, 0.5);
			box2.graphics.drawRect(0, 0, stage.stageWidth - 6, 32);
			box2.x = 3; box2.y = 25;
			box2.graphics.endFill();
			labelContainer.addChild(box2);
			box1.alpha = 0;
			box2.scaleX = 0;
			primaryLine.x = 6;
			secondaryLine.x = 6;
			secondaryLine.y = 24;
			labelContainer.addChild(primaryLine);
			labelContainer.addChild(secondaryLine);
			addChild(labelContainer);
		}
		
		private function loadJoystick():void
		{
			var clipLoader:Loader = new Loader();
			clipLoader.load(new URLRequest("lib/joystick.swf"));
			clipLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, clipLoaded);				
		}
		
		private function clipLoaded(e:Event):void
		{
			joystickClip = e.currentTarget.content as MovieClip;
			addChild (joystickClip);
			prepareLabel();
			defineEventsHandling();
		}
		
		private function defineEventsHandling():void
		{
			joystickClip.addEventListener("Esquimo3D.MOUSE_OVER", mouseOverHandler);	
			joystickClip.addEventListener("Esquimo3D.MOUSE_OUT", mouseOutHandler);
		}
		
		private function mouseOverHandler(e:MouseEvent):void
		{
			labelContainer.visible = true;	
			var whichone:int = e.delta;
			switch (whichone) 
			{
				case 11: displayInfo(0); break;
				case 12: displayInfo(1); break;
				case 6: displayInfo(2); break;
				case 8: displayInfo(3); break;
				case 7: displayInfo(4); break;
				case 1: case 2: case 3: case 4: case 5: displayInfo(5); break;
			}
		}
		
		private function mouseOutHandler(e:MouseEvent):void
		{
			Actuate.tween (labelContainer, 2, { alpha:0 } ).delay(1);
		}
		
		private function displayInfo(id:int):void
		{
			Actuate.tween (labelContainer, 0, { alpha:1 } );
			primaryLine.text = controllerNames[id];
			secondaryLine.text = additionalDesc[id];
			box1.alpha = 1;
			box2.scaleX = 0;
			secondaryLine.alpha = 0;
			Actuate.tween (box1, 0.5, { alpha:0.4 } );
			Actuate.tween (box2, 0.8, { scaleX:1} ).delay(0.5);
			Actuate.tween (secondaryLine, 0.8, { alpha:1} ).delay(0.7);
		}
	}
}